<!-- 编辑弹窗 -->
<template>
  <ele-modal
    :width="800"
    :visible="visible"
    :maskClosable="false"
    :maxable="maxable"
    :title="isUpdate ? '编辑患者' : '添加患者'"
    :body-style="{ paddingBottom: '28px' }"
    @update:visible="updateVisible"
    @ok="save"
  >
    <a-form
      ref="formRef"
      :model="form"
      :rules="rules"
      :label-col="styleResponsive ? { md: 4, sm: 5, xs: 24 } : { flex: '90px' }"
      :wrapper-col="
        styleResponsive ? { md: 19, sm: 19, xs: 24 } : { flex: '1' }
      "
    >
      <!--      <a-form-item label="类型 0经销商 1企业 2集团" name="type">-->
      <!--        <a-input-->
      <!--          allow-clear-->
      <!--          placeholder="请输入类型 0经销商 1企业 2集团"-->
      <!--          v-model:value="form.type"-->
      <!--        />-->
      <!--      </a-form-item>-->
      <a-form-item v-if="isUpdate" label="用户ID" name="userId">
        {{ form.userId }}
      </a-form-item>
      <a-form-item label="姓名" name="realName">
        <a-input
          allow-clear
          placeholder="请输入姓名"
          v-model:value="form.realName"
        />
      </a-form-item>
      <a-form-item label="手机号" name="phone">
        <a-input
          allow-clear
          placeholder="请输入手机号"
          disabled
          v-model:value="form.phone"
        />
      </a-form-item>
      <a-form-item label="年龄" name="age">
        <a-input-number
          :min="0"
          :max="999"
          class="ele-fluid"
          placeholder="请输入年龄"
          v-model:value="form.age"
        />
      </a-form-item>
      <a-form-item label="身高" name="height">
        <a-input-number
          :min="0"
          :max="999"
          class="ele-fluid"
          placeholder="请输入身高"
          v-model:value="form.height"
        />
      </a-form-item>
      <a-form-item label="体重" name="weight">
        <a-input-number
          :min="0"
          :max="999"
          class="ele-fluid"
          placeholder="请输入体重"
          v-model:value="form.weight"
        />
      </a-form-item>
      <a-form-item label="过敏史" name="allergyHistory">
        <a-textarea
          :rows="4"
          :maxlength="200"
          placeholder="请输入过敏史"
          v-model:value="form.allergyHistory"
        />
      </a-form-item>
      <a-form-item label="备注" name="comments">
        <a-textarea
          :rows="4"
          :maxlength="200"
          placeholder="请输入描述"
          v-model:value="form.comments"
        />
      </a-form-item>
      <a-form-item label="排序号" name="sortNumber">
        <a-input-number
          :min="0"
          :max="9999"
          class="ele-fluid"
          placeholder="请输入排序号"
          v-model:value="form.sortNumber"
        />
      </a-form-item>
    </a-form>
  </ele-modal>
</template>

<script lang="ts" setup>
  import { ref, reactive, watch } from 'vue';
  import { Form, message } from 'ant-design-vue';
  import { assignObject } from 'ele-admin-pro';
  import {
    addClinicPatientUser,
    updateClinicPatientUser
  } from '@/api/clinic/clinicPatientUser';
  import { ClinicPatientUser } from '@/api/clinic/clinicPatientUser/model';
  import { useThemeStore } from '@/store/modules/theme';
  import { storeToRefs } from 'pinia';
  import { ItemType } from 'ele-admin-pro/es/ele-image-upload/types';
  import { FormInstance } from 'ant-design-vue/es/form';

  // 是否是修改
  const isUpdate = ref(false);
  const useForm = Form.useForm;
  // 是否开启响应式布局
  const themeStore = useThemeStore();
  const { styleResponsive } = storeToRefs(themeStore);

  const props = defineProps<{
    // 弹窗是否打开
    visible: boolean;
    // 修改回显的数据
    data?: ClinicPatientUser | null;
  }>();

  const emit = defineEmits<{
    (e: 'done'): void;
    (e: 'update:visible', visible: boolean): void;
  }>();

  // 提交状态
  const loading = ref(false);
  // 是否显示最大化切换按钮
  const maxable = ref(true);
  // 表格选中数据
  const formRef = ref<FormInstance | null>(null);
  const images = ref<ItemType[]>([]);

  // 用户信息
  const form = reactive<ClinicPatientUser>({
    id: undefined,
    type: undefined,
    userId: undefined,
    realName: undefined,
    phone: undefined,
    age: undefined,
    height: undefined,
    weight: undefined,
    allergyHistory: undefined,
    qrcode: undefined,
    comments: undefined,
    tenantId: undefined,
    createTime: undefined,
    sortNumber: 100
  });

  /* 更新visible */
  const updateVisible = (value: boolean) => {
    emit('update:visible', value);
  };

  // 表单验证规则
  const rules = reactive({
    clinicPatientUserName: [
      {
        required: true,
        type: 'string',
        message: '请填写患者名称',
        trigger: 'blur'
      }
    ]
  });

  const { resetFields } = useForm(form, rules);

  /* 保存编辑 */
  const save = () => {
    if (!formRef.value) {
      return;
    }
    formRef.value
      .validate()
      .then(() => {
        loading.value = true;
        const formData = {
          ...form
        };
        const saveOrUpdate = isUpdate.value
          ? updateClinicPatientUser
          : addClinicPatientUser;
        saveOrUpdate(formData)
          .then((msg) => {
            loading.value = false;
            message.success(msg);
            updateVisible(false);
            emit('done');
          })
          .catch((e) => {
            loading.value = false;
            message.error(e.message);
          });
      })
      .catch(() => {});
  };

  watch(
    () => props.visible,
    (visible) => {
      if (visible) {
        images.value = [];
        if (props.data) {
          assignObject(form, props.data);
          isUpdate.value = true;
        } else {
          isUpdate.value = false;
        }
      } else {
        resetFields();
      }
    },
    { immediate: true }
  );
</script>
